#obtain seconds for given string time

#echo $1 $2
out=$""
start=$(date '+%s' -d $2)
end=$(date '+%s' -d $3)
#echo $((end-start))

#remove header using awk and making file only in comma seprated
inp_file=$(cat $1 | awk -F'[\t,]' '{ if (NR!=1) printf( "%s,%s,%s,%s\n",$1,$2,$3,$4)}')
#echo "$inp_file" > pure_csv_processed_file


#storing into pure_csv_processed_file for sort command to read
#scince file contains both comma and tab seperator hence using both in awk
#col.s:---- fullname----useraction-----timestamp-------time------
#also sort by name then pipe the output to awk
name=$(echo "$inp_file"| sort | awk -F'[\t,]' '{ printf( "%s\n",$1)}')
action=$(echo "$inp_file"| sort | awk -F'[\t,]' '{ printf( "%s\n",$2)}')
time=$(echo "$inp_file"| sort | awk -F'[\t,]' '{ printf( "%s\n",$4)}')

#note: double quote to display with line break echo "$name""$action""$time"
#algo:--------------------------------------------------------------------------------------------------
#eleminate duplicates from name list
#for each line in unique_name
#	match untill each line for same name gets over in $name
#		keep time corresponing to Joined action to one list say joined
#		keep time corresponing to Left action to one list say left
#	sort the join and left list
#	after obtaining lists left and joined look for start=>joined[i] and first left[i] <=end obtain first join and first left find the diff in sec
#	...and then iterate till end of any list is achived and go on adding time
#	
#	after obtaining total time in second store in global list of time corressponding to name uniqye_name list
#end-----------------------------------------------------------------------------------------------------
unique_name=$(echo "$name" | uniq)
first_line=1
while IFS= read -r uniq_name_line; do
	line_no=1
#	echo "... $uniq_name ..."
	count_sec=0
	left_itr=0
	joined_itr=0
	left_list=()
	joined_list=()
	while IFS= read -r redun_name; do
		#echo $redun_name
		if [ "$uniq_name_line" = "$redun_name" ]; then
			#echo $name
			ac=$(echo "$action"| awk -v lno=$line_no '{  if (NR==lno) printf( "%s",$1)}')
			tm=$(echo "$time"| awk -v lno=$line_no '{  if (NR==lno) printf( "%s",$1)}')
			
			if [ "$ac" == "Left" ]; then
				left_list=(${left_list[@]} "$tm")
				left_itr=$(($left_itr+1))
			fi

			if [ "$ac" == "Joined" ]; then
				joined_list=(${joined_list[@]} "$tm")
				joined_itr=$(($joined_itr+1))
			fi
		fi
		line_no=$((line_no+1))
	
	done <<< "$name"
	
	#echo $uniq_name_line
	#finding min number of element between joined_list and left list
	N=${#joined_list[@]}
	if [ ${#joined_list[@]} -lt ${#left_list[@]} ]; then
		N=${#left_list[@]}
	fi
	
	itr=0
	while [ $itr -lt $N ]
	do
		#if array[i] contain element then ------- else ++++++
		if [ "${left_list[$itr]}" != "" ]; then
			t1=$(date +%s -d "${left_list[$itr]}")
			t2=$(date +%s -d "${joined_list[$itr]}")
			#typecast
			typeset -i t1 t2 start end
			#echo "++++++"
			#echo ${left_list[$itr]}
			#echo ${joined_list[$itr]}
			#echo "-------"
				if [ $t2 -lt $t1 -a $t1 -lt $end -a $t2 -gt $start ]; then
			
					count_sec=$((t1-t2+count_sec))
					elif [ $t2 -lt $t1 -a $t1 -lt $end -a $t2 -lt $start ]; then
	
					count_sec=$((t1-start+count_sec))
					elif [ $t2 -lt $t1 -a $t1 -gt $end -a $t2 -gt $start ]; then

					count_sec=$(($end-t2+count_sec))
				elif [ $t2 -lt $t1 -a $t1 -gt $end -a $t2 -lt $start ]; then

					count_sec=$((end-start+count_sec))
				fi
		else
			t2=$(date +%s -d "${joined_list[$itr]}")
			#typecasting
			typeset -i t2 end start
			if [ $t2 -le $start ]; then
				count_sec=$((end-start+count_sec))
			elif [ $t2 -gt $start ]; then
				count_sec=$((end-t2+count_sec))
			fi			
			
		fi
		

		itr=$((itr+1))
	done

	tot_time_in_sec=$count_sec
	#convert into hh:mm:ss
	hh=$(((tot_time_in_sec)/3600))
	mm=$((((tot_time_in_sec)-(3600*$hh))/60))
	ss=$(((tot_time_in_sec)-(3600*$hh)-(60*$mm)))
	
	#adjusting line break at first or last line
	if [ $first_line != 1 ]; then
		out=$out$'\n'$uniq_name_line$'\t'"$(printf "%02d:%02d:%02d" $hh $mm $ss)"
	else
		out=$uniq_name_line$'\t'"$(printf "%02d:%02d:%02d" $hh $mm $ss)"
	fi
	first_line=$(($first_line+1)) 
	line_no=1
done <<< "$unique_name"
echo "$out" > out01

