#clear out all empty lines
sed -i '/^$/d' $1

#extract line reffernce number of https and grep gives <line_no>:<https://.......> use cut to delete after 1st occurance of :
a=$(cat $* | grep -n 'https' | cut -d : -f 1)

#algo:
#find name: first line and for rest line after https
#find project: after first line and before https contains project. Combine lines if in multiple lines
#find https: already in $a
#combine all three using||
#repeat from start

name_line_no=1
#name=$(cat $* | awk '{if(NR==name_line_no) print $0}')
#extract name of first student
name=$(cat $* | sed -n "${name_line_no}p")

#intializing the file to be outputed with Name||Projects||Drive Video Link \n
output='Name||Projects||Drive Video Link'
separator='||'
for l in ${a[@]};
do
	#extract link
	link=$(cat $* | sed -n "${l}"p)

	#find no. of lines the project is mentioned
	no_lines_in_project=$((l-name_line_no-1))
	
	#combines all lines of project into one
	project_line_no=$((name_line_no+1))
	project=$(cat $* | sed -n "${project_line_no}p")
	itr=1
	while [ $itr -lt $no_lines_in_project ]
	do
	next_line=$((itr+project_line_no))
	project=$project$(cat $* | sed -n "${next_line}p")
	itr=$(($itr+1))	
	done
	

	#extract name
	name=$(cat $* | sed -n "${name_line_no}p")
	#before every name there should be a line break
	name=$'\n'$name
	#combine name||project||link
	
	output=$output$name$separator$project$separator$link
	name_line_no=$((l+1))
done

#redirecting output to file called csv in same directory
echo "$output" >> csv

